﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Persistence;

namespace Persistence.Migrations
{
    [DbContext(typeof(HelpAroundContext))]
    [Migration("20201126084702_InitDb")]
    partial class InitDb
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .UseIdentityColumns()
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("ProductVersion", "5.0.0");

            modelBuilder.Entity("Domain.Common.Address", b =>
                {
                    b.Property<long>("AddressId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<long>("DependantId")
                        .HasColumnType("bigint");

                    b.Property<string>("Door")
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<int?>("Floor")
                        .HasColumnType("int");

                    b.Property<int>("LocalityId")
                        .HasColumnType("int");

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<int>("Number")
                        .HasColumnType("int");

                    b.Property<int?>("Portal")
                        .HasColumnType("int");

                    b.Property<int>("ProvinceId")
                        .HasColumnType("int");

                    b.Property<string>("Stairs")
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<string>("Street")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("AddressId");

                    b.HasIndex("DependantId");

                    b.HasIndex("LocalityId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.HasIndex("ProvinceId");

                    b.ToTable("Address");
                });

            modelBuilder.Entity("Domain.Common.Locality", b =>
                {
                    b.Property<int>("LocalityId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .UseIdentityColumn();

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.Property<int>("ProvinceId")
                        .HasColumnType("int");

                    b.HasKey("LocalityId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.HasIndex("ProvinceId");

                    b.ToTable("Locality");
                });

            modelBuilder.Entity("Domain.Common.ModelBase", b =>
                {
                    b.Property<long>("ModelBaseId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<DateTime>("CreationDate")
                        .HasColumnType("datetime2");

                    b.Property<int>("RecordStatusId")
                        .HasColumnType("int");

                    b.Property<DateTime>("UpdateDate")
                        .HasColumnType("datetime2");

                    b.HasKey("ModelBaseId");

                    b.ToTable("ModelBase");
                });

            modelBuilder.Entity("Domain.Common.Province", b =>
                {
                    b.Property<int>("ProvinceId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .UseIdentityColumn();

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("ProvinceId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.ToTable("Province");
                });

            modelBuilder.Entity("Domain.Dependants.Dependant", b =>
                {
                    b.Property<long>("DependantId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<int>("DependantSituationId")
                        .HasColumnType("int");

                    b.Property<int>("DependantTypeId")
                        .HasColumnType("int");

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("DependantId");

                    b.HasIndex("DependantSituationId");

                    b.HasIndex("DependantTypeId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.ToTable("Dependant");
                });

            modelBuilder.Entity("Domain.Dependants.DependantSituation", b =>
                {
                    b.Property<int>("DependantSituationId")
                        .HasColumnType("int");

                    b.Property<string>("Value")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("DependantSituationId");

                    b.ToTable("DependantSituation");

                    b.HasData(
                        new
                        {
                            DependantSituationId = 1,
                            Value = "Quarantine"
                        },
                        new
                        {
                            DependantSituationId = 2,
                            Value = "Disabled"
                        },
                        new
                        {
                            DependantSituationId = 3,
                            Value = "MedicalReason"
                        });
                });

            modelBuilder.Entity("Domain.Dependants.DependantType", b =>
                {
                    b.Property<int>("DependantTypeId")
                        .HasColumnType("int");

                    b.Property<string>("Value")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("DependantTypeId");

                    b.ToTable("DependantType");

                    b.HasData(
                        new
                        {
                            DependantTypeId = 1,
                            Value = "Normal"
                        },
                        new
                        {
                            DependantTypeId = 2,
                            Value = "Risk"
                        });
                });

            modelBuilder.Entity("Domain.Products.Product", b =>
                {
                    b.Property<long>("ProductId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<string>("Detail")
                        .HasColumnType("nvarchar(max)");

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<double>("Price")
                        .HasColumnType("float");

                    b.HasKey("ProductId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.ToTable("Product");
                });

            modelBuilder.Entity("Domain.Products.ProductProvider", b =>
                {
                    b.Property<long>("ProductId")
                        .HasColumnType("bigint");

                    b.Property<long>("ProviderId")
                        .HasColumnType("bigint");

                    b.HasKey("ProductId", "ProviderId");

                    b.HasIndex("ProviderId");

                    b.ToTable("ProductProvider");
                });

            modelBuilder.Entity("Domain.Providers.Provider", b =>
                {
                    b.Property<long>("ProviderId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<TimeSpan>("Close")
                        .HasColumnType("time");

                    b.Property<bool>("IsAvailable")
                        .HasColumnType("bit");

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<TimeSpan>("Open")
                        .HasColumnType("time");

                    b.Property<string>("Phone")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("ProviderId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.ToTable("Provider");
                });

            modelBuilder.Entity("Domain.Transactions.Transaction", b =>
                {
                    b.Property<long>("TransactionId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<DateTime>("CreationDate")
                        .HasColumnType("datetime2");

                    b.Property<long>("DependantId")
                        .HasColumnType("bigint");

                    b.Property<bool>("IsAllowProductChange")
                        .HasColumnType("bit");

                    b.Property<int>("TransactionStatusId")
                        .HasColumnType("int");

                    b.Property<DateTime>("UpdateDate")
                        .HasColumnType("datetime2");

                    b.Property<long>("VoluntaryId")
                        .HasColumnType("bigint");

                    b.HasKey("TransactionId");

                    b.HasIndex("DependantId");

                    b.HasIndex("TransactionStatusId");

                    b.HasIndex("VoluntaryId");

                    b.ToTable("Transaction");
                });

            modelBuilder.Entity("Domain.Transactions.TransactionDetail", b =>
                {
                    b.Property<long>("TransactionDetailId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<double>("Price")
                        .HasColumnType("float");

                    b.Property<long>("ProductId")
                        .HasColumnType("bigint");

                    b.Property<long>("ProviderId")
                        .HasColumnType("bigint");

                    b.Property<int>("Quantity")
                        .HasColumnType("int");

                    b.Property<long>("TransactionId")
                        .HasColumnType("bigint");

                    b.HasKey("TransactionDetailId");

                    b.HasIndex("ProductId");

                    b.HasIndex("ProviderId");

                    b.HasIndex("TransactionId");

                    b.ToTable("TransactionDetail");
                });

            modelBuilder.Entity("Domain.Transactions.TransactionStatus", b =>
                {
                    b.Property<int>("TransactionStatusId")
                        .HasColumnType("int");

                    b.Property<string>("Value")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("TransactionStatusId");

                    b.ToTable("TransactionStatus");

                    b.HasData(
                        new
                        {
                            TransactionStatusId = 1,
                            Value = "Created"
                        },
                        new
                        {
                            TransactionStatusId = 2,
                            Value = "OnShopping"
                        },
                        new
                        {
                            TransactionStatusId = 3,
                            Value = "OnDelivery"
                        },
                        new
                        {
                            TransactionStatusId = 4,
                            Value = "Delivered"
                        },
                        new
                        {
                            TransactionStatusId = 5,
                            Value = "Canceled"
                        });
                });

            modelBuilder.Entity("Domain.Voluntaries.Voluntary", b =>
                {
                    b.Property<long>("VoluntaryId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .UseIdentityColumn();

                    b.Property<bool>("IsAvailable")
                        .HasColumnType("bit");

                    b.Property<long>("ModelBaseId")
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(200)
                        .HasColumnType("nvarchar(200)");

                    b.HasKey("VoluntaryId");

                    b.HasIndex("ModelBaseId")
                        .IsUnique();

                    b.ToTable("Voluntary");
                });

            modelBuilder.Entity("Domain.Common.Address", b =>
                {
                    b.HasOne("Domain.Dependants.Dependant", "Dependant")
                        .WithMany("Addresses")
                        .HasForeignKey("DependantId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Common.Locality", "Locality")
                        .WithMany("Addresses")
                        .HasForeignKey("LocalityId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Common.Address", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Common.Province", "Province")
                        .WithMany("Addresses")
                        .HasForeignKey("ProvinceId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Dependant");

                    b.Navigation("Locality");

                    b.Navigation("ModelBase");

                    b.Navigation("Province");
                });

            modelBuilder.Entity("Domain.Common.Locality", b =>
                {
                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Common.Locality", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Common.Province", "Province")
                        .WithMany("Localities")
                        .HasForeignKey("ProvinceId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("ModelBase");

                    b.Navigation("Province");
                });

            modelBuilder.Entity("Domain.Common.Province", b =>
                {
                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Common.Province", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("ModelBase");
                });

            modelBuilder.Entity("Domain.Dependants.Dependant", b =>
                {
                    b.HasOne("Domain.Dependants.DependantSituation", "DependantSituation")
                        .WithMany()
                        .HasForeignKey("DependantSituationId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Dependants.DependantType", "DependantType")
                        .WithMany()
                        .HasForeignKey("DependantTypeId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Dependants.Dependant", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("DependantSituation");

                    b.Navigation("DependantType");

                    b.Navigation("ModelBase");
                });

            modelBuilder.Entity("Domain.Products.Product", b =>
                {
                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Products.Product", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("ModelBase");
                });

            modelBuilder.Entity("Domain.Products.ProductProvider", b =>
                {
                    b.HasOne("Domain.Products.Product", "Product")
                        .WithMany("ProductProvider")
                        .HasForeignKey("ProductId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Providers.Provider", "Provider")
                        .WithMany("ProductProvider")
                        .HasForeignKey("ProviderId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Product");

                    b.Navigation("Provider");
                });

            modelBuilder.Entity("Domain.Providers.Provider", b =>
                {
                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Providers.Provider", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("ModelBase");
                });

            modelBuilder.Entity("Domain.Transactions.Transaction", b =>
                {
                    b.HasOne("Domain.Dependants.Dependant", "Dependant")
                        .WithMany("Transactions")
                        .HasForeignKey("DependantId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Transactions.TransactionStatus", "TransactionStatus")
                        .WithMany()
                        .HasForeignKey("TransactionStatusId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Voluntaries.Voluntary", "Voluntary")
                        .WithMany("Transactions")
                        .HasForeignKey("VoluntaryId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Dependant");

                    b.Navigation("TransactionStatus");

                    b.Navigation("Voluntary");
                });

            modelBuilder.Entity("Domain.Transactions.TransactionDetail", b =>
                {
                    b.HasOne("Domain.Products.Product", "Product")
                        .WithMany("TransactionDetails")
                        .HasForeignKey("ProductId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Providers.Provider", "Provider")
                        .WithMany("TransactionDetails")
                        .HasForeignKey("ProviderId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Domain.Transactions.Transaction", "Transaction")
                        .WithMany("TransactionDetails")
                        .HasForeignKey("TransactionId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Product");

                    b.Navigation("Provider");

                    b.Navigation("Transaction");
                });

            modelBuilder.Entity("Domain.Voluntaries.Voluntary", b =>
                {
                    b.HasOne("Domain.Common.ModelBase", "ModelBase")
                        .WithOne()
                        .HasForeignKey("Domain.Voluntaries.Voluntary", "ModelBaseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("ModelBase");
                });

            modelBuilder.Entity("Domain.Common.Locality", b =>
                {
                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("Domain.Common.Province", b =>
                {
                    b.Navigation("Addresses");

                    b.Navigation("Localities");
                });

            modelBuilder.Entity("Domain.Dependants.Dependant", b =>
                {
                    b.Navigation("Addresses");

                    b.Navigation("Transactions");
                });

            modelBuilder.Entity("Domain.Products.Product", b =>
                {
                    b.Navigation("ProductProvider");

                    b.Navigation("TransactionDetails");
                });

            modelBuilder.Entity("Domain.Providers.Provider", b =>
                {
                    b.Navigation("ProductProvider");

                    b.Navigation("TransactionDetails");
                });

            modelBuilder.Entity("Domain.Transactions.Transaction", b =>
                {
                    b.Navigation("TransactionDetails");
                });

            modelBuilder.Entity("Domain.Voluntaries.Voluntary", b =>
                {
                    b.Navigation("Transactions");
                });
#pragma warning restore 612, 618
        }
    }
}
